day04(11.2)——leetcode面试经典150

42. 接雨水

这题我一开始想的是从左到右遍历除了头尾的所有列,在第i列的时候,先从左边找到最高的一列,再从右边找到最高的一列,再来判断是左边的最高列更小还是右边的最高列更小,最后如果更小的最高列如果大于当前i的高度,则sum要加上他们之间的差值。。。但是这样就寄了,超时了,所以我看题解了哈哈哈哈,用了双指针的方法:

左边一个left指向最左边,右边一个right指向最右边,左边永远小于右边进行循环判断,判断一下当前左右两边的指针是否大于左右两边各自的高度最大值,如果大于,那就更新,如果小于,那就不用管了,然后再进行判断比较左边的最大值大,还是右边的最大值大,如果左边的最大值大,说明左边的墙更高,右边的墙更矮,右边的点只需要低于右边的最大值就能产生积水,所以先判断一下当前右边的点是否小于当前右边的最大值,如果小于,则他们的差值累加到积水的总值上,右边再往中间走一步,左边亦是如此.....

42. 接雨水

题目:

题解:

java 复制代码
class Solution {
    public int trap(int[] height) {
        // 左右指针指向索引
        int left = 0;
        int right = height.length-1;
        // 计算左边碰到最高的柱子的长度
        int leftMax = 0;
        //计算右边碰到最高的柱子的长度
        int rightMax = 0;
        // 用来统计积水
        int sum = 0;
        while(left < right) {
            // 更新当前左边的最高柱子的长度
            if(height[left] > leftMax) {
                leftMax = height[left];
            }
            // 更新当前右边的最高柱子的长度
            if(height[right] > rightMax) {
                rightMax = height[right];
            }
            //如果当前左边的最高柱子短于当前右边柱子的长度
            //此时说明左边如果有短于这个左边最长柱子长度的柱子,
            //那么就一定是积水,所以从左边开始统计积水
            if (leftMax < rightMax ) {
                sum+=(leftMax - height[left]);
                left++;
            }
            //右边更短亦是如此
            else {
                sum+=(rightMax - height[right]);
                right--;
            }
        }
        return sum;
    }
}
相关推荐
lzhdim5 小时前
AI的分类
人工智能·算法·机器学习·分类·数据挖掘
凤凰院凶涛QAQ8 小时前
《Java版数据结构 & 集合类剖析》Map & Set & 反射:“从哈希碰撞到红黑树转换,反射帮你扒开 HashMap 的桶数组看个究竟”
java·数据结构·算法
w_zero_one10 小时前
算法--模拟
java·数据结构·算法
秋天的怀念_David10 小时前
算法一千零一夜 · 第十三夜 幻方,武侠世界里的数学迷宫
java·程序人生·算法
秋天的怀念_David11 小时前
算法一千零一夜 · 第十四夜 幻方与奇妙的二进制
java·程序人生·算法
薛定e的猫咪11 小时前
(ICLR 2020)MAML 靠的不是快速学习,而是特征复用
人工智能·深度学习·学习·算法·机器学习
薛定e的猫咪11 小时前
(ICLR 2026)DF-META:面向 FJSP 的无导数元学习实例自适应调度
人工智能·深度学习·学习·算法·机器学习
java_nnnn13 小时前
LeetCode刷题滑动窗口(水果成篮+找到字符串中所有字母的异位词)Java
java·开发语言·leetcode
小羊没烦恼!13 小时前
异步编程:线程概述及使用
java·开发语言·mysql·算法·c#
wanderist.13 小时前
202609CSP认证P3
算法